<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: obstacles.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('obstacles_8cpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">obstacles.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="obstacles_8cpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="obstacles_8hh.html">obstacles.hh</a>&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno"><a class="line" href="class_rod.html#adcb64855f216b76960fcd78db56a3e52">    5</a></span>&#160;<a class="code" href="class_rod.html#adcb64855f216b76960fcd78db56a3e52">Rod::Rod</a>() {</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;    <span class="comment">// Open file with model coordinates of rod obstacle</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    ifstream inputFile;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    inputFile.open(kObstacleRodModel);</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="keywordflow">if</span> (!inputFile.is_open()) {</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to load model rod obstacle file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    }</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="comment">// Read all of model coordinates</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> point;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keywordflow">while</span> (inputFile &gt;&gt; point) {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        point = point + obstacleRodTranslation_;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        obstacleRod_.push_back(point);</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        allCounter_++; <span class="comment">// Increase counter of total number of Vector3D objects</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        currentCounter_++; <span class="comment">// Increase counter of current number of Vector3D objects</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="keywordflow">if</span> (!(point[0] &gt;= xMin)) xMin = point[0]; <span class="comment">// Calculate minimal value of coordinate on X axis</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keywordflow">if</span> (!(point[0] &lt;= xMax)) xMax = point[0]; <span class="comment">// Calculate maximal value of coordinate on X axis</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="keywordflow">if</span> (!(point[1] &gt;= yMin)) yMin = point[1]; <span class="comment">// Calculate minimal value of coordinate on Y axis</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keywordflow">if</span> (!(point[1] &lt;= yMax)) yMax = point[1]; <span class="comment">// Calculate maximal value of coordinate on Y axis</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keywordflow">if</span> (!(point[2] &gt;= zMin)) zMin = point[2]; <span class="comment">// Calculate minimal value of coordinate on Z axis</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keywordflow">if</span> (!(point[2] &lt;= zMax)) zMax = point[2]; <span class="comment">// Calculate maximal value of coordinate on Z axis</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    }</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    inputFile.close();</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;}</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="class_rod.html#a26e3e6f119b8d6a3747dd22626e9c07c">   36</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_rod.html#a26e3e6f119b8d6a3747dd22626e9c07c">Rod::draw</a>(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;rodFilename)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="comment">// Open file to which all coordinates will be saved</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    ofstream outputFile;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    outputFile.open(rodFilename);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordflow">if</span> (!outputFile.is_open()) {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to open obstacle rod file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    }</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="comment">// Save all coordinates to the result file</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; obstacleRod_.size(); ++i) {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        outputFile &lt;&lt; obstacleRod_[i] &lt;&lt; endl;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordflow">if</span> (i % 4 == 3) {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            outputFile &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        }</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    }</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;}</div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="class_rod.html#a8bd1e81ac1987a74913ed25e57769d92">   55</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="class_rod.html#a8bd1e81ac1987a74913ed25e57769d92">Rod::checkCollision</a>(<span class="keyword">const</span> std::vector&lt;Vector3D&gt; &amp;droneCover)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment">// Maximal and minimal values of coordinates of drone cover initialized with NaN values,</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment">// to assign the appropriate values to them at the first pass of the data download loop.</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">double</span> coverXMin = 0.0 / 0.0, coverXMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">double</span> coverYMin = 0.0 / 0.0, coverYMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">double</span> coverZMin = 0.0 / 0.0, coverZMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; droneCover.size(); ++i) {</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][0] &gt;= coverXMin)) coverXMin = droneCover[i][0]; <span class="comment">// Calculate minimal value on X axis</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][0] &lt;= coverXMax)) coverXMax = droneCover[i][0]; <span class="comment">// Calculate maximal value on X axis</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][1] &gt;= coverYMin)) coverYMin = droneCover[i][1]; <span class="comment">// Calculate minimal value on Y axis</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][1] &lt;= coverYMax)) coverYMax = droneCover[i][1]; <span class="comment">// Calculate maximal value on Y axis</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][2] &gt;= coverZMin)) coverZMin = droneCover[i][2]; <span class="comment">// Calculate minimal value on Z axis</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][2] &lt;= coverZMax)) coverZMax = droneCover[i][2]; <span class="comment">// Calculate maximal value on Z axis</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    }</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordflow">return</span> (coverXMin &lt;= xMax &amp;&amp; coverXMax &gt;= xMin) &amp;&amp; (coverYMin &lt;= yMax &amp;&amp; coverYMax &gt;= yMin)</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        &amp;&amp; (coverZMin &lt;= zMax &amp;&amp; coverZMax &gt;= zMin);</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;}</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="class_rectangle.html#a8a933e0ebd9e80ce91e61ffe87fd577e">   77</a></span>&#160;<a class="code" href="class_rectangle.html#a8a933e0ebd9e80ce91e61ffe87fd577e">Rectangle::Rectangle</a>() {</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="comment">// Open file with model coordinates of rectangle obstacle</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    ifstream inputFile;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    inputFile.open(kObstacleRectangleModel);</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordflow">if</span> (!inputFile.is_open()) {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to load model obstacle rectangle file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    }</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="comment">// Read all of model coordinates</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> point;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordflow">while</span> (inputFile &gt;&gt; point) {</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        point = point + obstacleRectangleTranslation_;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        obstacleRectangle_.push_back(point);</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        allCounter_++; <span class="comment">// Increase counter of total number of Vector3D objects</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        currentCounter_++; <span class="comment">// Increase counter of current number of Vector3D objects</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keywordflow">if</span> (!(point[0] &gt;= xMin)) xMin = point[0]; <span class="comment">// Calculate minimal value of coordinate on X axis</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordflow">if</span> (!(point[0] &lt;= xMax)) xMax = point[0]; <span class="comment">// Calculate maximal value of coordinate on X axis</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keywordflow">if</span> (!(point[1] &gt;= yMin)) yMin = point[1]; <span class="comment">// Calculate minimal value of coordinate on Y axis</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keywordflow">if</span> (!(point[1] &lt;= yMax)) yMax = point[1]; <span class="comment">// Calculate maximal value of coordinate on Y axis</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keywordflow">if</span> (!(point[2] &gt;= zMin)) zMin = point[2]; <span class="comment">// Calculate minimal value of coordinate on Z axis</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordflow">if</span> (!(point[2] &lt;= zMax)) zMax = point[2]; <span class="comment">// Calculate maximal value of coordinate on Z axis</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    }</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    inputFile.close();</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;}</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="class_rectangle.html#a3143df391fb8929ceb88f32638297cdc">  108</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_rectangle.html#a3143df391fb8929ceb88f32638297cdc">Rectangle::draw</a>(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;rectangleFilename)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="comment">// Open file to which all coordinates will be saved</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    ofstream outputFile;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    outputFile.open(rectangleFilename);</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">if</span> (!outputFile.is_open()) {</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to open obstacle rectangle file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    }</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment">// Save all coordinates to the result file</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; obstacleRectangle_.size(); ++i) {</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        outputFile &lt;&lt; obstacleRectangle_[i] &lt;&lt; endl;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordflow">if</span> (i % 4 == 3) {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            outputFile &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        }</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    }</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;}</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160; </div>
<div class="line"><a name="l00128"></a><span class="lineno"><a class="line" href="class_rectangle.html#a0e4f5f8306e4fcdd21fcb2e4c9fc301a">  128</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="class_rectangle.html#a0e4f5f8306e4fcdd21fcb2e4c9fc301a">Rectangle::checkCollision</a>(<span class="keyword">const</span> std::vector&lt;Vector3D&gt; &amp;droneCover)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="comment">// Maximal and minimal values of coordinates of drone cover initialized with NaN values,</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="comment">// to assign the appropriate values to them at the first pass of the data download loop.</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordtype">double</span> coverXMin = 0.0 / 0.0, coverXMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="keywordtype">double</span> coverYMin = 0.0 / 0.0, coverYMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordtype">double</span> coverZMin = 0.0 / 0.0, coverZMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; droneCover.size(); ++i) {</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][0] &gt;= coverXMin)) coverXMin = droneCover[i][0]; <span class="comment">// Calculate minimal value on X axis</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][0] &lt;= coverXMax)) coverXMax = droneCover[i][0]; <span class="comment">// Calculate maximal value on X axis</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][1] &gt;= coverYMin)) coverYMin = droneCover[i][1]; <span class="comment">// Calculate minimal value on Y axis</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][1] &lt;= coverYMax)) coverYMax = droneCover[i][1]; <span class="comment">// Calculate maximal value on Y axis</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][2] &gt;= coverZMin)) coverZMin = droneCover[i][2]; <span class="comment">// Calculate minimal value on Z axis</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][2] &lt;= coverZMax)) coverZMax = droneCover[i][2]; <span class="comment">// Calculate maximal value on Z axis</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    }</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <span class="keywordflow">return</span> (coverXMin &lt;= xMax &amp;&amp; coverXMax &gt;= xMin) &amp;&amp; (coverYMin &lt;= yMax &amp;&amp; coverYMax &gt;= yMin)</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        &amp;&amp; (coverZMin &lt;= zMax &amp;&amp; coverZMax &gt;= zMin);</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;}</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160; </div>
<div class="line"><a name="l00150"></a><span class="lineno"><a class="line" href="class_cuboid_obstacle.html#ac30b116e7a4684a2cf5403708b63359a">  150</a></span>&#160;<a class="code" href="class_cuboid_obstacle.html#ac30b116e7a4684a2cf5403708b63359a">CuboidObstacle::CuboidObstacle</a>() {</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="comment">// Open file with model coordinates of cuboid obstacle</span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    ifstream inputFile;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    inputFile.open(kObstacleCuboidModel);</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160; </div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="keywordflow">if</span> (!inputFile.is_open()) {</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to load model obstacle cuboid file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160; </div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="comment">// Read all of model coordinates</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> point;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="keywordflow">while</span> (inputFile &gt;&gt; point) {</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        point = point + obstacleCuboidTranslation_;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        obstacleCuboid_.push_back(point);</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        allCounter_++; <span class="comment">// Increase counter of total number of Vector3D objects</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        currentCounter_++; <span class="comment">// Increase counter of current number of Vector3D objects</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160; </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keywordflow">if</span> (!(point[0] &gt;= xMin)) xMin = point[0]; <span class="comment">// Calculate minimal value of coordinate on X axis</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordflow">if</span> (!(point[0] &lt;= xMax)) xMax = point[0]; <span class="comment">// Calculate maximal value of coordinate on X axis</span></div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        <span class="keywordflow">if</span> (!(point[1] &gt;= yMin)) yMin = point[1]; <span class="comment">// Calculate minimal value of coordinate on Y axis</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordflow">if</span> (!(point[1] &lt;= yMax)) yMax = point[1]; <span class="comment">// Calculate maximal value of coordinate on Y axis</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160; </div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keywordflow">if</span> (!(point[2] &gt;= zMin)) zMin = point[2]; <span class="comment">// Calculate minimal value of coordinate on Z axis</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keywordflow">if</span> (!(point[2] &lt;= zMax)) zMax = point[2]; <span class="comment">// Calculate maximal value of coordinate on Z axis</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    }</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    inputFile.close();</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;}</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160; </div>
<div class="line"><a name="l00181"></a><span class="lineno"><a class="line" href="class_cuboid_obstacle.html#a58601592d1866745e78d37d7b610c573">  181</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_cuboid_obstacle.html#a58601592d1866745e78d37d7b610c573">CuboidObstacle::draw</a>(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;cuboidObstacleFilename)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="comment">// Open file to which all coordinates will be saved</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    ofstream outputFile;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    outputFile.open(cuboidObstacleFilename);</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160; </div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keywordflow">if</span> (!outputFile.is_open()) {</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to open obstacle cuboid file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    }</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160; </div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <span class="comment">// Save all coordinates to the result file</span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; obstacleCuboid_.size(); ++i) {</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        outputFile &lt;&lt; obstacleCuboid_[i] &lt;&lt; endl;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        <span class="keywordflow">if</span> (i % 4 == 3) {</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            outputFile &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        }</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    }</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;}</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160; </div>
<div class="line"><a name="l00201"></a><span class="lineno"><a class="line" href="class_cuboid_obstacle.html#a3530598ee9d1ecc78d168ea978f8b79c">  201</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="class_cuboid_obstacle.html#a3530598ee9d1ecc78d168ea978f8b79c">CuboidObstacle::checkCollision</a>(<span class="keyword">const</span> std::vector&lt;Vector3D&gt; &amp;droneCover)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="comment">// Maximal and minimal values of coordinates of drone cover initialized with NaN values,</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;<span class="comment">// to assign the appropriate values to them at the first pass of the data download loop.</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="keywordtype">double</span> coverXMin = 0.0 / 0.0, coverXMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="keywordtype">double</span> coverYMin = 0.0 / 0.0, coverYMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keywordtype">double</span> coverZMin = 0.0 / 0.0, coverZMax = 0.0 / 0.0;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; droneCover.size(); ++i) {</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][0] &gt;= coverXMin)) coverXMin = droneCover[i][0]; <span class="comment">// Calculate minimal value on X axis</span></div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][0] &lt;= coverXMax)) coverXMax = droneCover[i][0]; <span class="comment">// Calculate maximal value on X axis</span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160; </div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][1] &gt;= coverYMin)) coverYMin = droneCover[i][1]; <span class="comment">// Calculate minimal value on Y axis</span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][1] &lt;= coverYMax)) coverYMax = droneCover[i][1]; <span class="comment">// Calculate maximal value on Y axis</span></div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160; </div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][2] &gt;= coverZMin)) coverZMin = droneCover[i][2]; <span class="comment">// Calculate minimal value on Z axis</span></div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="keywordflow">if</span> (!(droneCover[i][2] &lt;= coverZMax)) coverZMax = droneCover[i][2]; <span class="comment">// Calculate maximal value on Z axis</span></div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    }</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160; </div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <span class="keywordflow">return</span> (coverXMin &lt;= xMax &amp;&amp; coverXMax &gt;= xMin) &amp;&amp; (coverYMin &lt;= yMax &amp;&amp; coverYMax &gt;= yMin)</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        &amp;&amp; (coverZMin &lt;= zMax &amp;&amp; coverZMax &gt;= zMin);</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160; </div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclass_cuboid_obstacle_html_a58601592d1866745e78d37d7b610c573"><div class="ttname"><a href="class_cuboid_obstacle.html#a58601592d1866745e78d37d7b610c573">CuboidObstacle::draw</a></div><div class="ttdeci">void draw(const std::string &amp;cuboidObstacleFilename) const override</div><div class="ttdoc">Saves the rectangle obstacle coordinates to a result file.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00181">obstacles.cpp:181</a></div></div>
<div class="ttc" id="aobstacles_8hh_html"><div class="ttname"><a href="obstacles_8hh.html">obstacles.hh</a></div></div>
<div class="ttc" id="aclass_rectangle_html_a0e4f5f8306e4fcdd21fcb2e4c9fc301a"><div class="ttname"><a href="class_rectangle.html#a0e4f5f8306e4fcdd21fcb2e4c9fc301a">Rectangle::checkCollision</a></div><div class="ttdeci">bool checkCollision(const std::vector&lt; Vector3D &gt; &amp;droneCover) const override</div><div class="ttdoc">Checks if in the next step of movement will be collision with the rectangle.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00128">obstacles.cpp:128</a></div></div>
<div class="ttc" id="aclass_rectangle_html_a8a933e0ebd9e80ce91e61ffe87fd577e"><div class="ttname"><a href="class_rectangle.html#a8a933e0ebd9e80ce91e61ffe87fd577e">Rectangle::Rectangle</a></div><div class="ttdeci">Rectangle()</div><div class="ttdoc">Constructor for Rectangle class.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00077">obstacles.cpp:77</a></div></div>
<div class="ttc" id="aclass_rod_html_a8bd1e81ac1987a74913ed25e57769d92"><div class="ttname"><a href="class_rod.html#a8bd1e81ac1987a74913ed25e57769d92">Rod::checkCollision</a></div><div class="ttdeci">bool checkCollision(const std::vector&lt; Vector3D &gt; &amp;droneCover) const override</div><div class="ttdoc">Checks if in the next step of movement will be collision with the rod.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00055">obstacles.cpp:55</a></div></div>
<div class="ttc" id="aclass_rectangle_html_a3143df391fb8929ceb88f32638297cdc"><div class="ttname"><a href="class_rectangle.html#a3143df391fb8929ceb88f32638297cdc">Rectangle::draw</a></div><div class="ttdeci">void draw(const std::string &amp;rectangleFilename) const override</div><div class="ttdoc">Saves the rectangle obstacle coordinates to a result file.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00108">obstacles.cpp:108</a></div></div>
<div class="ttc" id="aclass_cuboid_obstacle_html_ac30b116e7a4684a2cf5403708b63359a"><div class="ttname"><a href="class_cuboid_obstacle.html#ac30b116e7a4684a2cf5403708b63359a">CuboidObstacle::CuboidObstacle</a></div><div class="ttdeci">CuboidObstacle()</div><div class="ttdoc">Constructor for CuboidObstacle class.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00150">obstacles.cpp:150</a></div></div>
<div class="ttc" id="aclass_vector_html"><div class="ttname"><a href="class_vector.html">Vector&lt; double, 3 &gt;</a></div></div>
<div class="ttc" id="aclass_cuboid_obstacle_html_a3530598ee9d1ecc78d168ea978f8b79c"><div class="ttname"><a href="class_cuboid_obstacle.html#a3530598ee9d1ecc78d168ea978f8b79c">CuboidObstacle::checkCollision</a></div><div class="ttdeci">bool checkCollision(const std::vector&lt; Vector3D &gt; &amp;droneCover) const override</div><div class="ttdoc">Checks if in the next step of movement will be collision with the cuboid.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00201">obstacles.cpp:201</a></div></div>
<div class="ttc" id="aclass_rod_html_adcb64855f216b76960fcd78db56a3e52"><div class="ttname"><a href="class_rod.html#adcb64855f216b76960fcd78db56a3e52">Rod::Rod</a></div><div class="ttdeci">Rod()</div><div class="ttdoc">Constructor for Rod class.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00005">obstacles.cpp:5</a></div></div>
<div class="ttc" id="aclass_rod_html_a26e3e6f119b8d6a3747dd22626e9c07c"><div class="ttname"><a href="class_rod.html#a26e3e6f119b8d6a3747dd22626e9c07c">Rod::draw</a></div><div class="ttdeci">void draw(const std::string &amp;rodFilename) const override</div><div class="ttdoc">Saves the rod obstacle coordinates to a result file.</div><div class="ttdef"><b>Definition:</b> <a href="obstacles_8cpp_source.html#l00036">obstacles.cpp:36</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_f77a644fded742ea05ed17fa0fdf6fe1.html">src</a></li><li class="navelem"><a class="el" href="obstacles_8cpp.html">obstacles.cpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
